//+------------------------------------------------------------------+
//|                                                           sd.mq4 |
//|                     Copyright ZD 2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright Ͻ 2010.11.5"
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 OrangeRed
#property indicator_color2 DeepSkyBlue
#property indicator_color3 OrangeRed
#property indicator_color4 DeepSkyBlue
#property indicator_color5 OrangeRed
#property indicator_color6 DeepSkyBlue
//---- input parameters
//---- buffers
extern int timeFrame=0;
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];

extern int period = 20;
bool g_bNarrow = false;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(4,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(5,DRAW_LINE,STYLE_DOT);
   SetIndexBuffer(5,ExtMapBuffer6);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   int limit=MathMax(Bars-counted_bars,3*timeFrame/Period());
   for(int i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
		double h1 = iBands(NULL,timeFrame,period,2,0,PRICE_CLOSE,MODE_UPPER,y);
		double h2 = iBands(NULL,timeFrame,period,2,0,PRICE_CLOSE,MODE_UPPER,y + 1);
		double l1 = iBands(NULL,timeFrame,period,2,0,PRICE_CLOSE,MODE_LOWER,y);
		double l2 = iBands(NULL,timeFrame,period,2,0,PRICE_CLOSE,MODE_LOWER,y + 1);
        double a1=iMA(NULL,timeFrame,period,0,MODE_SMA,PRICE_CLOSE,y);
        double a2=iMA(NULL,timeFrame,period,0,MODE_SMA,PRICE_CLOSE,y+1);

		ExtMapBuffer1[i]=EMPTY_VALUE;
		ExtMapBuffer2[i]=EMPTY_VALUE;
		ExtMapBuffer3[i]=EMPTY_VALUE;
		ExtMapBuffer4[i]=EMPTY_VALUE;
		ExtMapBuffer5[i]=EMPTY_VALUE;
		ExtMapBuffer6[i]=EMPTY_VALUE;

		if (h1 < h2 && l1 > l2)
		{
			g_bNarrow = true;
		}
		else if (h1 > h2 && l1 < l2)
		{
			g_bNarrow = false;
		}

		if (g_bNarrow)
		{
			ExtMapBuffer1[i] = h1;
			ExtMapBuffer3[i] = l1;
			ExtMapBuffer1[i + 1] = h2;
			ExtMapBuffer3[i + 1] = l2;
    	    ExtMapBuffer5[i]=a1;
		    ExtMapBuffer5[i + 1]=a2;
		}
		else
		{
			ExtMapBuffer2[i] = h1;
			ExtMapBuffer4[i] = l1;
			ExtMapBuffer2[i + 1] = h2;
			ExtMapBuffer4[i + 1] = l2;
    	    ExtMapBuffer6[i]=a1;
		    ExtMapBuffer6[i + 1]=a2;
		}
	 } //endfor
  
//----
   return(0);
}//endstart
//+------------------------------------------------------------------+